#!/bin/sh

. "$_EXEC/cgilite/storage.sh"
. "$_EXEC/indexmeta.sh"

for select in $(seq 1 $(POST_COUNT select)); do
  file="$_DATA/$ITEM/$(POST select $select)"
  meta="${file%/*}/.index/meta"

  fn="$(meta_name "$file")"
  read -r length width height tags comment discard <<-EOF
	$(meta_info "$file")
	EOF
  [ "${length%%[1-9]*}" -o "${width%%[1-9]*}" -o "${height%%[1-9]*}" = 0 ] \
  && read -r length width height discard <<-EOF
	$(meta_line "$file"; echo Rereading meta for "$file" >&2)
	EOF
  [ "${tags%%tags=*}" ] && tags='tags=';
  [ "${comment%%comment=*}" ] && comment='comment='

  if LOCK "$meta"; then
    grep -avF "	$fn" "$meta" >"${meta}.tmp"

    tags="$(UNSTRING "${tags#tags=}" |tr , '\n')"

    for tn in $(seq 1 $(POST_COUNT tag)); do
      tags="$(printf '%s\n%s' "$tags" "$(POST tag $tn)")"
    done
    tags="$(printf '%s\n%s' "$tags" "$(POST newtag |tr -d '\r')")"

    tags="$(printf %s "$tags" |sort -u |tr '\n' ,)"
    printf '%i\t%i\t%i\ttags=%s\t%s\t%s\n' \
           "$length" "$width" "$height" \
           "$(STRING "${tags#,}")" \
           "$comment" "$fn" \
    >>"${meta}.tmp"
    mv "${meta}.tmp" "$meta"

    RELEASE "$meta"
  fi
done
